unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeeGDIPlus, TeEngine, DBChart, TeeDBCrossTab, Series, DB, DBTables,
  ExtCtrls, TeeProcs, Chart, TeeComma, TeeDBCrossTabEditor, Grids, DBGrids,
  TeeChartGrid;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    TeeCommander1: TTeeCommander;
    Chart2: TChart;
    ChartGrid1: TChartGrid;
    ChartGrid2: TChartGrid;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    procedure SeriesGetMarkText(Sender:TChartSeries; ValueIndex:Integer; var MarkText:String);
    procedure ChartMouseMove(Sender: TObject; Shift: TShiftState; X,
                             Y: Integer);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses TeeTools;

var Table1: TTable;
    DBCrossTabSource1: TDBCrossTabSource;
    ClickedSeriesIndex, ClickedValueIndex: Integer;

procedure TForm1.FormCreate(Sender: TObject);
var i: Integer;
begin
  Chart1.View3D:=false;
  Chart2.View3D:=false;
  Chart2.Legend.Visible:=false;

  Table1:=TTable.Create(Self);
  with Table1 do
  begin;
    DatabaseName:='DBDEMOS';
    TableName:='orders';
    Filter:='SaleDate > 01-12-1994';
    Filtered:=true;
  end;

  DBCrossTabSource1:=TDBCrossTabSource.Create(Self);
  with DBCrossTabSource1 do
  begin
    GroupField:='ShipVIA';
    LabelField:='SaleDate';
    ValueField:='AmountPaid';
    DataSet:=Table1;
  end;

  Table1.Active:=true;
  DBCrossTabSource1.Active:=True;

  Chart1.AddSeries(TBarSeries).DataSource:=DBCrossTabSource1;

  for i:=0 to Chart1.SeriesCount-1 do
    with Chart1[i] as TBarSeries do
    begin
      Marks.Style:=smsValue;
      AutoBarSize:=true;
      OnGetMarkText:=SeriesGetMarkText;
    end;

  ClickedSeriesIndex:=-1;
  ClickedValueIndex:=-1;

  Chart1.OnMouseMove:=ChartMouseMove;
end;

procedure TForm1.SeriesGetMarkText(Sender:TChartSeries; ValueIndex:Integer; var MarkText:String);
begin
  if MarkText = '0' then
    MarkText:='';
end;

procedure TForm1.ChartMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var SeriesIndex, ValueIndex: Integer;
    tmpDate: TDateTime;
    Query1: TQuery;
    DataSource1: TDataSource;
begin
  for SeriesIndex:=0 to Chart1.SeriesCount-1 do
  begin
    ValueIndex:=Chart1[SeriesIndex].Clicked(X, Y);
    if ValueIndex>-1 then
    begin
      if (ClickedSeriesIndex=-1) and (ClickedValueIndex=-1) then
      begin
        Caption:='Series ' + IntToStr(SeriesIndex) + ', ValueIndex: ' +
                 IntToStr(ValueIndex) + ', Value: ' +
                 FormatFloat('#,##0.##', Chart1[SeriesIndex].YValue[ValueIndex]) +
                 ', Label: ' + Chart1[SeriesIndex].Labels[ValueIndex];

        {tmpDate:=StrToDateTimeDef(Chart1[SeriesIndex].Labels[ValueIndex], 0);
        if tmpDate<>0 then
        begin
          Query1:=TQuery.Create(Self);
          with Query1 do
          begin
            DatabaseName:='TeeChart Pro Database';
            SQL.Add('SELECT *');
            SQL.Add('FROM orders');
            SQL.Add('WHERE SALEDATE = ' + DateTimeToStr(tmpDate));
          end;

          DataSource1:=TDataSource.Create(Self);
          DataSource1.DataSet:=Query1;
          DBGrid1.DataSource:=DataSource1;

          Query1.Active:=true;
        end;}

        Chart2.RemoveAllSeries;
        if Chart1[0].Detail.Count>(SeriesIndex-1) then
        begin
          //Chart1[0].Detail[SeriesIndex-1].Color:=Chart1[0].ValueColor[SeriesIndex];
          //Chart1[0].Detail[SeriesIndex].ParentChart:=Chart2;
          Chart2.AddSeries(CloneChartSeries(Chart1[0].Detail[SeriesIndex-1]));
          Chart2.Title.Caption:=Chart1[0].Detail[SeriesIndex-1].Title;
        end;

        ClickedSeriesIndex:=SeriesIndex;
        ClickedValueIndex:=ValueIndex;
      end;

      Exit;
    end;
  end;

  ClickedSeriesIndex:=-1;
  ClickedValueIndex:=-1;
  Caption:='Move the mouse over a bar in the chart...';
end;

end.
